#!/usr/bin/tclsh
########################################################################
# Copyright (c) 2004 by Hartmut Schwarz, matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
########################################################################

# Liefert Informationen zu den Partituren der Spielwerk-Musik-CD

fconfigure stdout -encoding iso8859-1

proc getinfo { partitur what language rstatus } {
 upvar $rstatus status;
 # set info variables
 source "../info/default.textinfo.tcl"; 
 if { [file isfile "../info/textinfo.$partitur.tcl"] } {
  source "../info/textinfo.$partitur.tcl";
 }
 if { ![info exists $what$language] } {
  set result "";
  set status 2;
 } else {
  set result [set $what$language];
  set status 0;
 }
 return $result;
}

proc printall { partitur rstatus } {
 upvar $rstatus status;
 global $partitur;
 if { ![info exists $partitur] || ![array exists $partitur] } {
  puts "\[ERROR\] no information about track $partitur";
  set status 1;
 } else {
  foreach entry [lsort [array names $partitur]] {
   puts "set $entry {[set [set partitur]($entry)]}";
  }
 }
 return;
}

# Eingabe pruefen
if { $argc < 2 || $argc > 3 } {
 puts "$argv0 : get Clockwork-Music track information";
 puts "usage : $argv0 scorename infoname \[ language \]";
 exit 1;
}

# Informationen ausgeben
set status 0;
if { $argc == 3 } {
 set language [lindex $argv 2];
} else {
 set language "";
}
puts [getinfo [lindex $argv 0] [lindex $argv 1] $language status];
exit $status;
