# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript  "Eternal Father Strong to Save"      NOV-12-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ----------------------------------------------------- special procedures ---
proc play_chord_eternal {} {
 upvar 1 rCTX rCTX;
 TREEset $rCTX isze [expr int([TREEget $rCTX isze]*0.92)];
 play_chord;
 return;
}

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Titel
set stem [TREEnew $root {kybs 12 tmtv 3 fstp 2 isze 200 song play_chord_eternal}];
sprout $stem\
 {song {} vars {\
  {crtv 0 vlbs 74}
  {crtv 0 vlbs 74}
  {crtv 0 vlbs 74}
  {crtv 0 vlbs 77.5}
 }}\
 {csym C                                    cmod . chtv .125}\
 {csym C/C                                  cmod ,.;;',.'',.;',.;/,'.}\
 {csym (F,A,F,A,E,G,D,G)/(F,c,B)            cmod ,.,.,.,./.;..}\
 {csym (E,c,F#,d,D,B,D,G)/(A,G,B)           cmod ,.,.,.,./.;..}\
 {csym (E,G,D,F#,D,G,D)/(D,c,G,B)           cmod ,.,.,../,.;,.:}\
 {csym (D,F,D,F,C,E,C,E)//(B,g,c,g)         cmod ,.;;,.,.;,.;/;/,.,.}\
 {csym (E,G,E,G,D,F#,F#,B)/(C#,A,D,A,D#,A)  cmod ,.;;,.,.;,.;/,.;,.,.}\
 {csym (E,G,D#,F#,E,E,A)/(E,B,F#,B,G,B,A,c) cmod ,.,..,./,.,.,.,.}\
 {csym (E,G,D#,F#,E,E)/(B,A,G)              cmod ,.,.../...:}\
 {csym (C,E,C,E,C,F,C,F)/(Bb,A)             cmod ,.;;,.,.;,.;/;_.; cres 2}\
 {csym (D,F#,D,F#,D,G,F,G)/(c,B)            cmod ,.;;,.,.;,.;/;_.; chbt f./f.}\
 {csym (E,G,D,A,E,G,C,E)/(c,F#,G)           cmod ,.,.,.,./...; chbt f./f. cres -2}\
 {csym (C,D,B)-1/(G,F)                      cmod ',.;;./.. chtv .5}\
 {csym (C)/(C,E) cmod ./,. chtv .25 more { {rept 3 tmtv 9} {tmtv 24} }}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 60;
end $root 0.5;
