# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript      "Kadenz Variationen"             SEP-21-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Klassische Kadenz
set spiel [TREEnew $root {tmtv 1 chbt /.;;./.;;./.;;./.;;.}];
set ende  [TREEnew $root {tmtv 1 chbt /./././. kybs 12 cmod ..,rs}];
sprout $spiel {song {} vars {\
 {vlbs 74.0 cmod ...s  chbt /./././. kybs 12}\
 {vlbs 74.0 cmod ...s  chbt /./././. kybs 12}\
 {vlbs 76.0 cmod ,..s  chbt /.;;./.;;./.;;./.;;. kybs 24}\
 {vlbs 76.0 cmod .,.s  chbt /.;;./.;;./.;;./.;;. kybs 24}\
 {vlbs 78.0 cmod ...s  chbt /.;;./.;;./.;;./.;;. kybs 36}\
 {vlbs 80.0 cmod .,.s  chbt ./.;;./.;;./.;;./.;;. kybs 48}\
 {vlbs 80.0 cmod .,.rs chbt ./.;;./.;;./.;;./.;;. kybs 48}\
 {vlbs 78.0 cmod ...rs chbt /.;;./.;;./.;;./.;;. kybs 36}\
 {vlbs 76.0 cmod .,.rs chbt /.;;./.;;./.;;./.;;. kybs 24}\
 {vlbs 76.0 cmod ,..rs chbt /.;;./.;;./.;;./.;;. kybs 24}\
 {vlbs 74.0 cmod ...rs chbt /./././. kybs 12}\
 {vlbs 74.0 cmod ...rs chbt /./././. kybs 12}}}\
 {csym D////} {csym A-2////} {csym G-1////} {csym D////}\
 ;
sprout $ende\
 {vlbs 74.0 csym D////}\
 {vlbs 74.0 csym A-2////}\
 {vlbs 73.0 cmod {} chbt {} tmtv 1.7 csym G-1//}\
 {vlbs 73.0 cmod {} chbt {} tmtv 2.4 csym D}\
 {vlbs 72.0 tmtv 5.2 kybs 36 cmod ...rs csym D isze 0}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $spiel 240;
touch $ende 5;
end $root 0.75;
return;
# removed at the end (for a seamless link to kalinka)
 {vlbs 72.0 tmtv 3.4 cmod ;;;. kybs 48 csym (D)}\
