; --------------------------------------------------------------------------------
; Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public
; License along with this program; if not, write to the Free
; Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
; MA 02111-1307, USA.
; --------------------------------------------------------------------------------

sr     = 44100
kr     = 11025
ksmps  =     4
nchnls =     2

; --------------------------------------------------------------------------------
         instr 1 ; Ein Klavier, ein Klavier !
                 ; 88 Tasten zwischen A2 (27.5 Hz) bis c5 (4186 Hz)
; --------------------------------------------------------------------------------
         ; eingelesene Parameter
ifree    = p3             ; Freischwingzeit ( p3 wird neu berechnet -> s.u. )
ivol     = p4             ; Lautstaerke
ipch     = p5             ; Tonhoehe
imix     = p6             ; Mixfaktor
idst     = p7             ; Hoerabstand
iazm     = p8             ; Richtungswinkel
isze     = p9             ; Groessenfaktor
iang     = p10            ; Aufstellungswinkel
         ; gebildete Parameter
iamp     = ampdb(ivol)               ; Amplitude
icps     = cpspch(ipch)              ; Frequenz
icps0    = icps                      ; Frequenz Saite 0
icps1    = 0.999*icps0               ; Frequenz Saite 1
icps2    = 1.001*icps0               ; Frequenz Saite 2
iatt     = (ivol>63?(ivol>75?3:2):1) ; Anschlagstaerke 1, 2 oder 3
         ; unabhaengige Werte
ift1     = 1             ; f-Tab Nummer f. Frequenzbereich 1
ift2     = 2             ; f-Tab Nummer f. Frequenzbereich 2
ift3     = 3             ; f-Tab Nummer f. Frequenzbereich 3
ift4     = 4             ; f-Tab Nummer f. Frequenzbereich 4
ift5     = 5             ; f-Tab Nummer f. Frequenzbereich 5
ift6     = 6             ; f-Tab Nummer f. Frequenzbereich 6
ift7     = 7             ; f-Tab Nummer f. Anstiegs-Phase
iye      = .001          ; normierte Endamplitude
         ; Daempfungsverlauf berechnen
ia       = 1+16*(icps/4186)^2        ; Daempfungskoeffizient
ib       = (ifree>0?ia/ifree:100*ia) ; Freischwing-Daempfung ( 0 = keine )
ic       = 100*ia                    ; Daempfer-Daempfung
iy01     = 1+((icps-220)/193)^2      ; Anfangsamplitude f. < 220 Hz
iy02     = 1+((icps-1760)/2426)^2    ; Anfangsamplitude f. > 1760 Hz
iy0      = (icps<220?iy01:(icps<1760?1:iy02))
iy0      = .42*iy0                   ; Angleichung an my_piano !!!
ir4186   = (iatt>1?(iatt>2?0.0005:0.001):0.002); Anstiegszeit bei 4186 Hz
irise    = ir4186*(4186/icps)        ; frequenzabhaengige Anstiegszeit
iy1      = iy0*exp(-ib*ifree)        ; normierte Freischwing-Restamplitude
idec     = -(log(iye)+ib*ifree)/ic   ; Daempfungszeit
idec     = (idec < 0 ? .001 : idec)  ; wenn iye schon in Freischwing-Phase
idur     = irise + ifree + idec      ; Spieldauer neu berechnen
p3       = idur                      ; Standardparameter ueberschreiben !
         ; Funktionstabelle nach Frequenzbereich auswaehlen
ift      = (icps>110?ift2:ift1)      ; Bereich 0 - 110 Hz
ift      = (icps>220?ift3:ift)       ;       111 - 220
ift      = (icps>440?ift4:ift)       ;       221 - 440
ift      = (icps>880?ift5:ift)       ;       441 - 880
ift      = (icps>1760?ift6:ift)      ;       881 - 1760
         ; sonstiges
ibalance = .5-.00004*(2500-icps)     ; Kanal-Balance ( 0 = links ... 1 = rechts )
         ; Signal erzeugen
kenv     envlpx iy0, irise, idur, idec, ift7, iy1/iy0, iye/iy1
kamp     = imix*kenv*iamp                ; Gesamt-Amplitude
a0       oscili kamp, icps0, ift          ; Oszillator 0
a1       oscili kamp, icps1, ift          ; Oszillator 1
a3       oscili kamp, icps2, ift          ; Oszillator 2
         ; compose signals main, left, right
amain    = (iatt>1?(iatt>2?(a0+a1+a3)/3:(a0+a1)/2):a0)
aleft    = (1 - ibalance)*amain
aright   = ibalance*amain
         ; signal output
outs     aleft, aright
endin ; --------------------------------------------------------------------------
